// test2_timesec.cpp
// Glenn G. Chappell
// 3 Oct 2013
//
// For CS 202 Fall 2013
// Test program #2 for class TimeSec:
// operators: == !=

#include "timesec.h"  // For class TimeSec
#include "timesec.h"  // Double-inclusion test

#include <iostream>
using std::cout;
using std::endl;
using std::cin;
#include <string>
using std::string;
#include <sstream>
using std::ostringstream;


bool allGood = true;  // true if all tests pass so far


// testTimeSec_basic
// Test for class TimeSec: construction & print
// Prints results of tests, sets global allGood to false if any fail
void testTimeSec_basic()
{
    cout << endl;
    cout << "Test: construction & print" << endl;

    {
    TimeSec t;
    ostringstream os;
    t.print(os);
    string s = os.str();
    string ans = " 0:00:00";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }

    {
    TimeSec t(5);
    ostringstream os;
    t.print(os);
    string s = os.str();
    string ans = " 5:00:00";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }

    {
    TimeSec t(12);
    ostringstream os;
    t.print(os);
    string s = os.str();
    string ans = "12:00:00";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }

    {
    TimeSec t(3, 25);
    ostringstream os;
    t.print(os);
    string s = os.str();
    string ans = " 3:25:00";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }

    {
    TimeSec t(3, 5);
    ostringstream os;
    t.print(os);
    string s = os.str();
    string ans = " 3:05:00";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }

    {
    TimeSec t(11, 5, 16);
    ostringstream os;
    t.print(os);
    string s = os.str();
    string ans = "11:05:16";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }

    {
    TimeSec t(3, 5, 6);
    ostringstream os;
    t.print(os);
    string s = os.str();
    string ans = " 3:05:06";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }
}


// testTimeSec_equality
// Test for class TimeSec: equality & inequality
// Prints results of tests, sets global allGood to false if any fail
void testTimeSec_equality()
{
    cout << endl;
    cout << "Test: \"==\" and \"!=\" operators" << endl;

    {
    const TimeSec t1(1,2,3);
    const TimeSec t2(1,2,3);
    bool equal = (t1 == t2);
    cout << "Should be equal: "
         << (equal ? "equal" : "NOT equal") << endl;
    if (!equal)
        allGood = false;
    }

    {
    const TimeSec t1(1,2,3);
    const TimeSec t2(1,2,3);
    bool equal = !(t1 != t2);
    cout << "Should be equal: "
         << (equal ? "equal" : "NOT equal") << endl;
    if (!equal)
        allGood = false;
    }

    {
    const TimeSec t1(1,2,0);
    const TimeSec t2(1,2);
    bool equal = (t1 == t2);
    cout << "Should be equal: "
         << (equal ? "equal" : "NOT equal") << endl;
    if (!equal)
        allGood = false;
    }

    {
    const TimeSec t1(1,2,0);
    const TimeSec t2(1,2);
    bool equal = !(t1 != t2);
    cout << "Should be equal: "
         << (equal ? "equal" : "NOT equal") << endl;
    if (!equal)
        allGood = false;
    }

    {
    const TimeSec t1(1,0);
    const TimeSec t2(1);
    bool equal = (t1 == t2);
    cout << "Should be equal: "
         << (equal ? "equal" : "NOT equal") << endl;
    if (!equal)
        allGood = false;
    }

    {
    const TimeSec t1(1,0);
    const TimeSec t2(1);
    bool equal = !(t1 != t2);
    cout << "Should be equal: "
         << (equal ? "equal" : "NOT equal") << endl;
    if (!equal)
        allGood = false;
    }

    {
    const TimeSec t1(0);
    const TimeSec t2;
    bool equal = (t1 == t2);
    cout << "Should be equal: "
         << (equal ? "equal" : "NOT equal") << endl;
    if (!equal)
        allGood = false;
    }

    {
    const TimeSec t1(0);
    const TimeSec t2;
    bool equal = !(t1 != t2);
    cout << "Should be equal: "
         << (equal ? "equal" : "NOT equal") << endl;
    if (!equal)
        allGood = false;
    }

    {
    const TimeSec t1(1,2,3);
    const TimeSec t2(1,2,4);
    bool equal = (t1 == t2);
    cout << "Should NOT be equal: "
         << (equal ? "equal" : "NOT equal") << endl;
    if (equal)
        allGood = false;
    }

    {
    const TimeSec t1(1,2,3);
    const TimeSec t2(1,2,4);
    bool equal = !(t1 != t2);
    cout << "Should NOT be equal: "
         << (equal ? "equal" : "NOT equal") << endl;
    if (equal)
        allGood = false;
    }

    {
    const TimeSec t1(1,2,3);
    const TimeSec t2(1,5,3);
    bool equal = (t1 == t2);
    cout << "Should NOT be equal: "
         << (equal ? "equal" : "NOT equal") << endl;
    if (equal)
        allGood = false;
    }

    {
    const TimeSec t1(1,2,3);
    const TimeSec t2(1,5,3);
    bool equal = !(t1 != t2);
    cout << "Should NOT be equal: "
         << (equal ? "equal" : "NOT equal") << endl;
    if (equal)
        allGood = false;
    }

    {
    const TimeSec t1(1,2,3);
    const TimeSec t2(7,2,3);
    bool equal = (t1 == t2);
    cout << "Should NOT be equal: "
         << (equal ? "equal" : "NOT equal") << endl;
    if (equal)
        allGood = false;
    }

    {
    const TimeSec t1(1,2,3);
    const TimeSec t2(7,2,3);
    bool equal = !(t1 != t2);
    cout << "Should NOT be equal: "
         << (equal ? "equal" : "NOT equal") << endl;
    if (equal)
        allGood = false;
    }
}


// main program
// Runs tests for class TimeSec, prints results
int main()
{
    testTimeSec_basic();
    testTimeSec_equality();
    
    cout << endl;
    if (allGood)
        cout << "All tests pass!" << endl;
    else
        cout << "***** SOME TESTS FAILED *****" << endl;

    cout << endl;
    cout << "Press ENTER to quit ";
    while (cin.get() != '\n') ;

    return 0;
}

